on startMovie
  global gLastRecipeLine, gPhotoSprite, gEditorSprites, gFractions, gLastCurrentRecipe, gLastCurrentBook, gCurrentRecipe, gCurrentBook, gHelpSprite, gCurrentCategory
  set gLastRecipeLine to 0
  set gPhotoSprite to 25
  set gEditorSprites to [2, 3, 8, 9, 10, 11, 12, 13, 24, 28, 32]
  if the machineType = 256 then
    set the textHeight of field "instructions scroll" to 14
    set the textSize of field "instructions scroll" to 12
    set the textStyle of field "instructions scroll" to "plain"
    set the textFont of field "instructions scroll" to "arial"
    set the textHeight of field "instructions" to 14
    set the textSize of field "instructions" to 12
    set the textStyle of field "instructions" to "plain"
    set the textFont of field "instructions" to "arial"
    set the textHeight of field "ingredients scroll" to 14
    set the textSize of field "ingredients scroll" to 12
    set the textStyle of field "ingredients scroll" to "plain"
    set the textFont of field "ingredients" to "arial"
    set the textHeight of field "ingredients" to 14
    set the textSize of field "ingredients" to 12
    set the textStyle of field "ingredients" to "plain"
    set the textFont of field "ingredients" to "arial"
  else
    set the textHeight of field "instructions scroll" to 14
    set the textSize of field "instructions scroll" to 12
    set the textStyle of field "instructions scroll" to "plain"
    set the textFont of field "instructions scroll" to "helvetica"
    set the textHeight of field "instructions" to 14
    set the textSize of field "instructions" to 12
    set the textStyle of field "instructions" to "plain"
    set the textFont of field "instructions" to "helvetica"
    set the textHeight of field "ingredients scroll" to 14
    set the textSize of field "ingredients scroll" to 12
    set the textStyle of field "ingredients scroll" to "plain"
    set the textFont of field "ingredients" to "helvetica"
    set the textHeight of field "ingredients" to 14
    set the textSize of field "ingredients" to 12
    set the textStyle of field "ingredients" to "plain"
    set the textFont of field "ingredients" to "helvetica"
  end if
  set gFractions to ["0", "1/16", "1/8", "3/16", "1/4", "5/16", "1/3", "3/8", "7/16", "1/2", "9/16", "5/8", "2/3", "11/16", "3/4", "13/16", "7/8", "15/16"]
  set gLastCurrentRecipe to gCurrentRecipe
  set gLastCurrentBook to gCurrentBook
  updateRecipes()
  loadCategoryNames()
  loadPersonalIndexes()
  set gHelpSprite to 48
  helpOff()
  set gCurrentCategory to 1
  Index()
end

on stopMovie
  global gPersonalIDDB, gPersonalBrowser, gCurrentBook, gCFTBook
  loadPersonalIndexes()
  if (count(gPersonalIDDB) > 0) and (count(gPersonalBrowser) > 0) then
    nothing()
  else
    set gCurrentBook to gCFTBook
  end if
  saveCategoryNames()
  saveRecipe()
  cleanLegos()
end

on Index
  global gEditorType
  saveRecipe()
  set gEditorType to #new
  put " " into field "indexScroll"
  indexPhotoOff()
  cleanLegos()
  go("index")
  set the selEnd to 0
  makeIndexScrolls()
  makeIndexButtons()
  set gInBSnotMade to 1
  setCategoryButton()
end

on indexNoSave
  global gEditorType
  set gEditorType to #new
  put " " into field "indexScroll"
  indexPhotoOff()
  cleanLegos()
  go("index")
  set the selEnd to 0
  makeIndexScrolls()
  makeIndexButtons()
  set gInBSnotMade to 1
  setCategoryButton()
end

on editor
  global gEditorType, gLastTitle, gLastCategory, gCurrentCategory, gIngredientsScroll, gInstructionsScroll
  editorOff()
  cleanCategoryNames()
  clearEditor()
  if gEditorType = #book then
    DBBookToPersonal()
  else
    if gEditorType = #personal then
      DBEditPersonal()
    else
      put "Untitled" into field "title"
    end if
  end if
  set gLastTitle to field "title"
  set gLastCategory to gCurrentCategory
  cleanLegos()
  go("editor")
  set the selEnd to 0
  makeEditorScrolls()
  makeEditorButtons()
  set gEdBSnotMade to 1
  categoriesMenu()
  dishesMenu()
  timesMenu()
  setCategoryMenu()
  if (gEditorType = #book) or (gEditorType = #personal) then
    setCurrentMenus()
  end if
  controlPosition(gIngredientsScroll, 0.0)
  controlPosition(gInstructionsScroll, 0.0)
  editorOn()
end

on category1
  global gCurrentCategory, gCategory1
  clearLastLine()
  set gCurrentCategory to 1
  if gCategory1 = EMPTY then
    put "Empty" into field "indexScroll"
  else
    if gCategory1 = "Empty" then
      put "Empty" into field "indexScroll"
    else
      put gCategory1 into field "indexScroll"
    end if
  end if
  selectRecipe(1)
end

on category2
  global gCurrentCategory, gCategory2
  clearLastLine()
  set gCurrentCategory to 2
  if gCategory2 = EMPTY then
    put "Empty" into field "indexScroll"
  else
    if gCategory2 = "Empty" then
      put "Empty" into field "indexScroll"
    else
      put gCategory2 into field "indexScroll"
    end if
  end if
  selectRecipe(1)
end

on category3
  global gCurrentCategory, gCategory3
  clearLastLine()
  set gCurrentCategory to 3
  if gCategory3 = EMPTY then
    put "Empty" into field "indexScroll"
  else
    if gCategory3 = "Empty" then
      put "Empty" into field "indexScroll"
    else
      put gCategory3 into field "indexScroll"
    end if
  end if
  selectRecipe(1)
end

on category4
  global gCurrentCategory, gCategory4
  clearLastLine()
  set gCurrentCategory to 4
  if gCategory4 = EMPTY then
    put "Empty" into field "indexScroll"
  else
    if gCategory4 = "Empty" then
      put "Empty" into field "indexScroll"
    else
      put gCategory4 into field "indexScroll"
    end if
  end if
  selectRecipe(1)
end

on category5
  global gCurrentCategory, gCategory5
  clearLastLine()
  set gCurrentCategory to 5
  if gCategory5 = EMPTY then
    put "Empty" into field "indexScroll"
  else
    if gCategory5 = "Empty" then
      put "Empty" into field "indexScroll"
    else
      put gCategory5 into field "indexScroll"
    end if
  end if
  selectRecipe(1)
end

on updateRecipes
  global gPersonalRecipes
  loadPersonalIndexes()
  set sentList to EMPTY
  set number to count(gPersonalRecipes)
  if number = 0 then
    set sentList to "(send recipes here from recipe screen)"
  else
    if number = 1 then
      set sentList to getAt(gPersonalRecipes, 1) & RETURN
    else
      set sentList to getAt(gPersonalRecipes, 1) & RETURN
      repeat with i = 2 to number
        put getAt(gPersonalRecipes, i) & RETURN after sentList
      end repeat
    end if
  end if
  put sentList into field "sentScroll"
end

on selectRecipe lineNum
  global gCurrentBook, gCurrentRecipe, gLastRecipeLine, gRecipeIDDB, gPersonalIDDB, gPhotoSprite
  if lineNum < 1 then
    exit
  end if
  if gLastRecipeLine = lineNum then
    exit
  end if
  set theRecipe to line lineNum of field "indexScroll"
  if (theRecipe = EMPTY) or (theRecipe = "Empty") then
    exit
  end if
  set the textStyle of line gLastRecipeLine of field "indexScroll" to "plain"
  set gLastRecipeLine to lineNum
  set gCurrentRecipe to getaProp(gRecipeIDDB, theRecipe)
  if gCurrentRecipe = 0 then
    set gCurrentBook to "personal"
    set gCurrentRecipe to getaProp(gPersonalIDDB, theRecipe)
  else
    if (gCurrentRecipe > 1700) and (gCurrentRecipe < 1772) then
      set gCurrentBook to "Pasta"
      set the castNum of sprite gPhotoSprite to the number of cast "index photo"
    else
      if (gCurrentRecipe > 1800) and (gCurrentRecipe < 1869) then
        set gCurrentBook to "Vegi"
        set the castNum of sprite gPhotoSprite to the number of cast "index photo"
      else
        if (gCurrentRecipe > 1900) and (gCurrentRecipe < 1969) then
          set gCurrentBook to "Stir"
          set the castNum of sprite gPhotoSprite to the number of cast "index photo"
        else
          if (gCurrentRecipe > 2000) and (gCurrentRecipe < 2069) then
            set gCurrentBook to "Chick"
            set the castNum of sprite gPhotoSprite to the number of cast "index photo"
          end if
        end if
      end if
    end if
  end if
  updateIndexPhoto()
  set gCurrentBook to "personal"
  set the visible of sprite gPhotoSprite to 1
  set the textStyle of line lineNum of field "indexScroll" to "bold"
end

on addRecipe
  global gCurrentCategory, gPersonalIDDB
  loadPersonalIndexes()
  set lineNum to the mouseLine
  if lineNum < 1 then
    exit
  end if
  set aLine to line lineNum of field "sentScroll"
  if (aLine = EMPTY) or (aLine = "(send recipes here from recipe screen)") then
    exit
  end if
  clearLastLine()
  DBBeginSaveSession()
  set newID to DBSetRecord("personal recipe", "0^" & aLine & "^0^" & gCurrentCategory & "^cat^1^2^inst^0^cup^nil^ingr^0")
  addProp(gPersonalIDDB, aLine, newID)
  DBEndSession()
  if field "indexScroll" = "Empty" then
    put aLine into field "indexScroll"
  else
    set Index to stringToList(removeReturns2(field "indexScroll"))
    add(Index, aLine)
    sort(Index)
    put listToString2(Index) into field "indexScroll"
  end if
  updateCurrentCategory()
  selectRecipe(1)
end

on editRecipe
  global gCurrentRecipe, gLastRecipeLine, gEditorType
  loadPersonalIndexes()
  helpOff()
  if field "indexScroll" = "Empty" then
    set gEditorType to #new
  else
    if gCurrentRecipe < 2069 then
      set gEditorType to #book
      put line gLastRecipeLine of field "indexScroll" into field "title"
    else
      if gCurrentRecipe >= 6000 then
        set gEditorType to #personal
        put line gLastRecipeLine of field "indexScroll" into field "title"
      end if
    end if
  end if
  editor()
end

on deleteRecipe
  global gLastRecipeLine, gRecipeIDDB, gPersonalIDDB, gCurrentCategory
  loadPersonalIndexes()
  if field "indexScroll" = "Empty" then
    exit
  end if
  set theRecipe to line gLastRecipeLine of field "indexScroll"
  set num to count(gPersonalIDDB)
  repeat with i = 1 to num
    set title to getPropAt(gPersonalIDDB, i)
    if title = theRecipe then
      set id to getAt(gPersonalIDDB, i)
      DBBeginSaveSession()
      DBGetSetRecord(id, "personal recipe")
      set category to integer(DBGetSetField(3004))
      DBEndSession()
      if category = gCurrentCategory then
        deleteProp(gPersonalIDDB, theRecipe)
        DBBeginSaveSession()
        DBDeleteRecord("personal recipe", integer(id))
        DBEndSession()
        delete line gLastRecipeLine of field "indexScroll"
        delete line gLastRecipeLine of field "indexScroll"
        clearLastLine()
        if (field "indexScroll" = EMPTY) or (field "indexScroll" = RETURN) then
          set the textStyle of line gLastRecipeLine of field "indexScroll" to "plain"
          put "Empty" into field "indexScroll"
          indexPhotoOff()
        else
          set gLastRecipeLine to 0
          selectRecipe(1)
        end if
        updateCurrentCategory()
        exit repeat
      end if
    end if
  end repeat
end

on addIngredient
  global gIngredientsScroll
  cleanEditor()
  if (field "fraction" = 0) and (field "quantity" = 0) then
    set quantity to EMPTY
  else
    if field "fraction" = 0 then
      set quantity to field "quantity" & " "
    else
      if field "quantity" = "0" then
        set quantity to field "fraction" & " "
      else
        set quantity to field "quantity" & "-" & field "fraction" & " "
      end if
    end if
  end if
  if (field "unit" = "empty") or (removeSpace(field "unit") = EMPTY) then
    set unit to " "
  else
    set unit to field "unit" & " "
  end if
  if (field "ingredient" = "empty") or (removeSpace(field "ingredient") = EMPTY) then
    set ingredient to " "
  else
    set ingredient to field "ingredient"
  end if
  set aLine to quantity & unit & ingredient
  if aLine <> "  " then
    put aLine & RETURN & RETURN before field "ingredients"
  end if
  controlPosition(gIngredientsScroll, 0.0)
end

on checkUnit
  if the selStart = 0 then
    put " " into field "unit"
    exit
  end if
  set theWord to char 1 to the selStart of field "unit"
  put theWord into field "unit"
  set theField to field "units"
  set fieldNum to length(theField)
  set num to length(theWord)
  repeat with i = 1 to fieldNum
    if theWord = char 1 to num of line i of theField then
      put line i of theField into field "unit"
      exit repeat
    end if
  end repeat
end

on quantityUp
  set num to integer(field "quantity")
  set doOnce to 1
  repeat while the mouseDown or doOnce
    if num < 9999 then
      set num to num + 1
    end if
    put num into field "quantity"
    waste()
    set doOnce to 0
  end repeat
end

on quantityDown
  set num to integer(field "quantity")
  set doOnce to 1
  repeat while the mouseDown or doOnce
    if num > 0 then
      set num to num - 1
    end if
    put num into field "quantity"
    waste()
    set doOnce to 0
  end repeat
end

on fractionUp
  global gFractions
  set num to getPos(gFractions, field "fraction")
  set doOnce to 1
  repeat while the mouseDown or doOnce
    if num < 18 then
      set num to num + 1
    end if
    put getAt(gFractions, num) into field "fraction"
    waste()
    set doOnce to 0
  end repeat
end

on fractionDown
  global gFractions
  set num to getPos(gFractions, field "fraction")
  set doOnce to 1
  repeat while the mouseDown or doOnce
    if num > 1 then
      set num to num - 1
    end if
    put getAt(gFractions, num) into field "fraction"
    waste()
    set doOnce to 0
  end repeat
end

on categoriesMenu
  global gCategoriesMenu
  set gCategoriesMenu to birth(script "pull down menu", 22, 23, the number of cast "menu", the number of cast "button", "categories", field "Category1" & RETURN & field "Category2" & RETURN & field "Category3" & RETURN & field "Category4" & RETURN & field "Category5", "setCurrentCategory")
end

on dishesMenu
  global gDishesMenu
  set gDishesMenu to birth(script "pull down menu", 26, 27, the number of cast "menu", the number of cast "button", "dishes", "Appetizers & Snacks" & RETURN & "Main Dishes" & RETURN & "Side Dishes, Breads & Rolls" & RETURN & "Soup, Salad & Sandwiches" & RETURN & "Desserts & Beverages")
end

on timesMenu
  global gTimesMenu
  set gTimesMenu to birth(script "pull down menu", 30, 31, the number of cast "menu", the number of cast "button", "times", "Less than 15 minutes" & RETURN & "Less than 30 minutes" & RETURN & "Less than 1 hour" & RETURN & "Less than 2 hours" & RETURN & "Less than 4 hours")
end

on makeIndexScrolls
  global gCategoryScroll, gSentScroll
  set track to new("Button", [#spriteChan: 33])
  set ball to new("Button", [#spriteChan: 34, #pressedCast: 96])
  set up to new("Button", [#spriteChan: 35, #pressedCast: 98])
  set down to new("Button", [#spriteChan: 36, #pressedCast: 100])
  set gCategoryScroll to new("ScrollBar", [#scrollSprite: 2, #minButton: up, #maxButton: down, #thumbButton: ball, #trackButton: track])
  set track to new("Button", [#spriteChan: 37])
  set ball to new("Button", [#spriteChan: 38, #pressedCast: 96])
  set up to new("Button", [#spriteChan: 39, #pressedCast: 98])
  set down to new("Button", [#spriteChan: 40, #pressedCast: 100])
  set gSentScroll to new("ScrollBar", [#scrollSprite: 3, #minButton: up, #maxButton: down, #thumbButton: ball, #trackButton: track])
end

on makeEditorScrolls
  global gIngredientsScroll, gInstructionsScroll
  set track to new("Button", [#spriteChan: 33])
  set ball to new("Button", [#spriteChan: 34, #pressedCast: 96])
  set up to new("Button", [#spriteChan: 35, #pressedCast: 98])
  set down to new("Button", [#spriteChan: 36, #pressedCast: 100])
  set gIngredientsScroll to new("ScrollBar", [#scrollField: "ingredients", #scrollFieldOut: 2, #minButton: up, #maxButton: down, #thumbButton: ball, #trackButton: track])
  set track to new("Button", [#spriteChan: 37])
  set ball to new("Button", [#spriteChan: 38, #pressedCast: 96])
  set up to new("Button", [#spriteChan: 39, #pressedCast: 98])
  set down to new("Button", [#spriteChan: 40, #pressedCast: 100])
  set gInstructionsScroll to new("ScrollBar", [#scrollField: "instructions", #scrollFieldOut: 3, #minButton: up, #maxButton: down, #thumbButton: ball, #trackButton: track])
end

on updateCurrentCategory
  global gCurrentCategory, gCategory1, gCategory2, gCategory3, gCategory4, gCategory5
  if gCurrentCategory = 1 then
    set gCategory1 to field "indexScroll"
  else
    if gCurrentCategory = 2 then
      set gCategory2 to field "indexScroll"
    else
      if gCurrentCategory = 3 then
        set gCategory3 to field "indexScroll"
      else
        if gCurrentCategory = 4 then
          set gCategory4 to field "indexScroll"
        else
          if gCurrentCategory = 5 then
            set gCategory5 to field "indexScroll"
          end if
        end if
      end if
    end if
  end if
end

on setCurrentCategory
  global gCurrentCategory, gCategory1, gCategory2, gCategory3, gCategory4, gCategory5
  set category to field "categories"
  if category = field "category1" then
    set gCurrentCategory to 1
    put gCategory1 into field "indexScroll"
  else
    if category = field "category2" then
      set gCurrentCategory to 2
      put gCategory2 into field "indexScroll"
    else
      if category = field "category3" then
        set gCurrentCategory to 3
        put gCategory3 into field "indexScroll"
      else
        if category = field "category4" then
          set gCurrentCategory to 4
          put gCategory4 into field "indexScroll"
        else
          if category = field "category5" then
            set gCurrentCategory to 5
            put gCategory5 into field "indexScroll"
          end if
        end if
      end if
    end if
  end if
end

on setCategoryMenu
  global gCategoriesMenu, gCurrentCategory
  controlSelection(gCategoriesMenu, gCurrentCategory)
end

on setCurrentMenus
  global gDishesMenu, gTimesMenu, gCurrentDishType, gCurrentPrepTime
  if gCurrentDishType = "Appetizers and Snacks" then
    set dishNum to 1
  else
    if gCurrentDishType = "Main Dishes" then
      set dishNum to 2
    else
      if gCurrentDishType = "Side Dishes, Breads and Rolls" then
        set dishNum to 3
      else
        if gCurrentDishType = "Soup, Salad and Sandwiches" then
          set dishNum to 4
        else
          if gCurrentDishType = "Desserts and Beverages" then
            set dishNum to 5
          else
            set dishNum to gCurrentDishType
          end if
        end if
      end if
    end if
  end if
  if not getPos([1, 2, 3, 4, 5], dishNum) then
    set dishNum to 1
  end if
  controlSelection(gDishesMenu, dishNum)
  if gCurrentPrepTime < 15 then
    set timeNum to 1
  else
    if gCurrentPrepTime < 30 then
      set timeNum to 2
    else
      if gCurrentPrepTime < 60 then
        set timeNum to 3
      else
        if gCurrentPrepTime < 120 then
          set timeNum to 4
        else
          if gCurrentPrepTime < 240 then
            set timeNum to 5
          else
            set timeNum to gCurrentPrepTime - 1000
          end if
        end if
      end if
    end if
  end if
  if not getPos([1, 2, 3, 4, 5], timeNum) then
    set dishNum to 1
  end if
  controlSelection(gTimesMenu, timeNum)
end

on getCurrentDishType
  set dishType to field "dishes"
  if dishType = "Appetizers & Snacks" then
    set dishNum to 1
  else
    if dishType = "Main Dishes" then
      set dishNum to 2
    else
      if dishType = "Side Dishes, Breads & Rolls" then
        set dishNum to 3
      else
        if dishType = "Soup, Salad & Sandwiches" then
          set dishNum to 4
        else
          if dishType = "Desserts & Beverages" then
            set dishNum to 5
          end if
        end if
      end if
    end if
  end if
  return dishNum
end

on getCurrentPrepTime
  set prepTime to field "times"
  if prepTime = "Less than 15 minutes" then
    set timeNum to 1
  else
    if prepTime = "Less than 30 minutes" then
      set timeNum to 2
    else
      if prepTime = "Less than 1 hour" then
        set timeNum to 3
      else
        if prepTime = "Less than 2 hours" then
          set timeNum to 4
        else
          if prepTime = "Less than 4 hours" then
            set timeNum to 5
          end if
        end if
      end if
    end if
  end if
  return timeNum
end

on clearEditor
  put "0" into field "servings"
  put " " into field "ingredients"
  put " " into field "ingredients scroll"
  put "Enter recipe instructions here" into field "instructions"
  put "Enter recipe instructions here" into field "instructions scroll"
  put "0" into field "quantity"
  put "0" into field "fraction"
  put "empty" into field "unit"
  put "empty" into field "ingredient"
end

on clearLastLine
  global gLastRecipeLine, gCategoryScroll
  indexPhotoOff()
  set the textStyle of line gLastRecipeLine of field "indexScroll" to "plain"
  set gLastRecipeLine to 0
  controlPosition(gCategoryScroll, 0.0)
end

on indexPhotoOff
  global gPhotoSprite
  set the visible of sprite gPhotoSprite to 0
end

on editorOn
  global gEditorSprites
  repeat with i in gEditorSprites
    set the visible of sprite i to 1
  end repeat
end

on editorOff
  global gEditorSprites
  repeat with i in gEditorSprites
    set the visible of sprite i to 0
  end repeat
end

on loadCategoryNames
  global gDBResult
  DBBeginSaveSession()
  DBGetSetRecord(1, "personal category")
  if gDBResult = 0 then
    put DBGetSetField(5001) into field "category1"
  end if
  DBGetSetRecord(2, "personal category")
  if gDBResult = 0 then
    put DBGetSetField(5001) into field "category2"
  end if
  DBGetSetRecord(3, "personal category")
  if gDBResult = 0 then
    put DBGetSetField(5001) into field "category3"
  end if
  DBGetSetRecord(4, "personal category")
  if gDBResult = 0 then
    put DBGetSetField(5001) into field "category4"
  end if
  DBGetSetRecord(5, "personal category")
  if gDBResult = 0 then
    put DBGetSetField(5001) into field "category5"
  end if
  DBEndSession()
end

on saveCategoryNames
  cleanCategoryNames()
  DBBeginSaveSession()
  set category1 to 1 & "^" & field "category1"
  set category2 to 2 & "^" & field "category2"
  set category3 to 3 & "^" & field "category3"
  set category4 to 4 & "^" & field "category4"
  set category5 to 5 & "^" & field "category5"
  DBSetRecord("personal category", category1)
  DBSetRecord("personal category", category2)
  DBSetRecord("personal category", category3)
  DBSetRecord("personal category", category4)
  DBSetRecord("personal category", category5)
  DBEndSession()
end

on cleanCategoryNames
  put removeCarrots(line 1 of field "category1") into field "category1"
  put removeCarrots(line 1 of field "category2") into field "category2"
  put removeCarrots(line 1 of field "category3") into field "category3"
  put removeCarrots(line 1 of field "category4") into field "category4"
  put removeCarrots(line 1 of field "category5") into field "category5"
end

on cleanEditor
  put line 1 of field "title" into field "title"
  put line 1 of field "servings" into field "servings"
  put line 1 of field "unit" into field "unit"
  put line 1 of field "ingredient" into field "ingredient"
end

on waste
  startTimer()
  repeat while the timer < 10
    nothing()
  end repeat
end

on makeIndexButtons
  global gMainButton, gBackButton, gHelpButton, gCategoryButton1, gCategoryButton2, gCategoryButton3, gCategoryButton4, gCategoryButton5, gEditButton, gDeleteButton
  set gMainButton to birth(script "GACButton", 5)
  set gHelpButton to birth(script "GACButton", 7)
  set gBackButton to birth(script "GACButton", 6)
  set gCategoryButton1 to birth(script "radioButton", 16)
  set gCategoryButton2 to birth(script "radioButton", 17)
  set gCategoryButton3 to birth(script "radioButton", 18)
  set gCategoryButton4 to birth(script "radioButton", 19)
  set gCategoryButton5 to birth(script "radioButton", 20)
  set gEditButton to birth(script "GACButton", 22)
  set gDeleteButton to birth(script "GACButton", 23)
end

on makeEditorButtons
  global gMainButton, gBackButton, gAddButton, gSaveButton
  set gMainButton to birth(script "GACButton", 5)
  set gBackButton to birth(script "GACButton", 6)
  set gAddButton to birth(script "GACButton", 47)
  set gSaveButton to birth(script "GACButton", 21)
end

on setCategoryButton
  global gCurrentCategory, gCategoryButton1, gCategoryButton2, gCategoryButton3, gCategoryButton4, gCategoryButton5
  if gCurrentCategory = 1 then
    select(gCategoryButton1)
    category1()
  else
    if gCurrentCategory = 2 then
      select(gCategoryButton2)
      category2()
    else
      if gCurrentCategory = 3 then
        select(gCategoryButton3)
        category3()
      else
        if gCurrentCategory = 4 then
          select(gCategoryButton4)
          category4()
        else
          if gCurrentCategory = 5 then
            select(gCategoryButton5)
            category5()
          end if
        end if
      end if
    end if
  end if
end

on saveRecipe
  global gCurrentRecipe, gRecipeIDDB, gPersonalIDDB, gCurrentCategory, theTitle, theNumber, gLastTitle, gLastCategory
  if the frame <> label("editor") then
    exit
  end if
  cleanEditor()
  cursor(4)
  DBBeginSaveSession()
  set title to removeCarrots(field "title")
  if removeSpace(title) = EMPTY then
    set title to "Untitled"
  end if
  set theTitle to title
  set theNumber to 1
  noDuplicateTitles()
  set title to theTitle
  set servings to integer(removeCarrots(field "servings"))
  if not integerp(servings) then
    set servings to 0
  end if
  set aString to 0 & "^" & title & "^" & servings & "^" & gCurrentCategory & "^" & "collate^" & getCurrentDishType() & "^" & getCurrentPrepTime() & "^" & removeCarrots(field "instructions")
  set ingredients to removeCarrots(field "ingredients")
  set ingredientsNum to the number of lines in ingredients
  repeat with i = 1 to ingredientsNum
    set aLine to line i of ingredients
    if (aLine <> EMPTY) or (ingredientsNum = 1) then
      set ingredient to aLine
      put "^0^unit^nil^" & ingredient & " ^0" after aString
    end if
  end repeat
  set newID to DBSetRecord("personal recipe", aString)
  addProp(gPersonalIDDB, title, newID)
  if (field "indexScroll" = "Empty") or (field "indexScroll" = EMPTY) then
    put title into field "indexScroll"
  else
    set Index to stringToList(removeReturns2(field "indexScroll"))
    add(Index, title)
    sort(Index)
    put listToString2(Index) into field "indexScroll"
  end if
  updateCurrentCategory()
  DBEndSession()
  cursor(-1)
end

on noDuplicateTitles
  global theTitle, theNumber, gRecipeIDDB, gPersonalIDDB
  set Index to field "indexScroll"
  set indexNum to the number of lines in Index
  set duplicateP to getaProp(gPersonalIDDB, theTitle)
  if voidp(duplicateP) then
    set duplicateP to getaProp(gRecipeIDDB, theTitle)
  end if
  if not voidp(duplicateP) then
    if (theTitle contains "(") and (theTitle contains ")") then
      set place1 to offset("(", theTitle) + 1
      set place2 to offset(")", theTitle) - 1
      set number to integer(char place1 to place2 of theTitle)
      if not integerp(number) then
        set theNumber to 1
      else
        set theNumber to integer(number + 1)
      end if
      put theNumber into char place1 to place2 of theTitle
    else
      set theNumber to integer(theNumber + 1)
      put "(" & theNumber & ")" after theTitle
    end if
    noDuplicateTitles()
    exit
  end if
end

on helpOn
  global gLastHelp, gHelpLinks, gHelpActive, gHelpSprite
  if gHelpActive then
    helpOff()
  else
    set gHelpActive to 1
    set gLastHelp to 0
    if the frame = label("editor") then
      set gHelpLinks to [5: 19, 6: 23, 7: 1, 8: 83, 9: 84, 10: 88, 11: 88, 24: 85, 28: 86, 32: 87, 41: 89, 42: 90, 43: 88, 44: 88, 45: 88, 46: 88, 47: 92, 3: 91]
    else
      set gHelpLinks to [5: 19, 6: 23, 7: 1, 2: 117, 3: 97, 16: 116, 17: 116, 18: 116, 19: 116, 20: 116, 22: 98, 23: 99]
    end if
    puppetSprite(gHelpSprite, 1)
  end if
end
